'// Multiple examples
#include once "fbList.bi"


'// This is just for the examples
#define numExamples		32
dim shared as integer nExample

'// Simple sequential Insert
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as t_List myList, myShorthandList
	
	print "Simple sequential insert works with any ptr, integer, arrays, and other lists"
	for i as integer = 0 to ubound(ScrambledNumbers)
		myList.Insert(ScrambledNumbers(i))
	next
	print "	List after Insert ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	print
	
	print "Shorthand += can also be used (Except for arrays)"
	for i as integer = 0 to ubound(ScrambledNumbers)
		myShorthandList += ScrambledNumbers(i)
	next
	print "	List after += ["& myShorthandList.Length &" entries]"
	Print "		"& myShorthandList.CSV() '// Get string of Comma Separated Values
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope








'// Easy insert of arrays and t_Lists
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as t_List myList
	
	print "Any ptr or integer ARRAYS can still be easily inserted with the .Insert syntax"
	myList.Insert(ScrambledNumbers())
	
	print "	List after Insert ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Initialize a list when it's created
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as integer ScrambledNumbers2(3) => {-1, -2, -3, -4}
	
	print "Constructor assignment is also supported"
	dim as t_List myList = ScrambledNumbers()
	dim as t_List otherList = myList
	
	print "	List after dim ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList = otherList
	print "	List after list assignment ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope



'// Inline ForEach for simple iteration
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as t_List myList = ScrambledNumbers()
	
	print "Use ForEach(index) to easily iterate over items in a list"
	myList.ForEach(i as integer)
		print "["& i &"] = "& myList[i];
		if i < myList.Length - 1 then
			print ", ";
		end if
	next
	print
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope



'// Insert at specific index
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {1, 2, 3, 4, 5, 6, 7, 8}
	dim as t_List myList = ScrambledNumbers()
	
	print "Insert can be passed an explicit index"
	myList.Insert(777, 0)			'// 0 is always the first item
	myList.Insert(999, 5)
	myList.Insert(333, LIST_LAST)	'// LIST_LAST is defined as -1, and is identical to not passing an index
	
	print "	List after Inserts ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Clearing a list
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {10, 20, 30, 40, 50}
	dim as t_List myList = ScrambledNumbers()
	
	print "Clearing a list"
	print "	List before Clear ["& myList.Length &" entries]"
	Print "		"& myList.CSV() &""
	
	myList.Clear()
	
	print "	List after Clear ["& myList.Length &" entries]"
	Print "		"& myList.CSV() &"<It's a blank string>"
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Clearing a list to values
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {10, 20, 30, 40, 50}
	dim as integer InitNumbers(3) => {100, 200, 300, 400}
	dim as t_List myList = ScrambledNumbers()
	
	print "We can use Clear to set a List to specific values"
	print "	List before Clear ["& myList.Length &" entries]"
	Print "		"& myList.CSV() &""
	
	myList.Clear(InitNumbers())
	
	print "	List after Clear(array) ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope






'// Removing an entry
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {10, 20, 30, 40, 50}
	dim as t_List myList = ScrambledNumbers()
	
	print "Removing an entry is simple"
	print "	List before Remove ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.Remove(2) '// Remove the value at index 2, which is 30
	
	print "	List after Remove(2) ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Replacing an entry
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {1, 2, 3, 4, 5}
	dim as t_List myList = ScrambledNumbers()
	
	print "Replacing an entry is also simple"
	print "	List before Replace ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.Replace(999, 2) '// Replace the value at index 2 with 999
	
	print "	List after Replace ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Replace will not insert new elements
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers1(4) => {0, 1, 2, 3, 4}
	dim as integer ScrambledNumbers2(3) => {10, 11, 12, 13}
	dim as t_List myList
	
	print "Replace does not insert new elements"
	
	myList.Insert(ScrambledNumbers1())
	print "	List before Replace ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	
	myList.Replace(ScrambledNumbers2(), 3)
	print "	List after Replace ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Use merge to combine/overwrite lists
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers1(4) => {0, 1, 2, 3, 4}
	dim as integer ScrambledNumbers2(3) => {10, 11, 12, 13}
	dim as t_List myList
	
	print "Use Merge to combine and overwrite lists while also inserting new elements"
	
	myList.Insert(ScrambledNumbers1())
	print "	List before Merge ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	
	myList.Merge(ScrambledNumbers2(), 3)
	print "	List after Merge ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Sorting a list
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as t_List myList = ScrambledNumbers()
	
	print "An existing list can easily be sorted"
	myList.Sort()
	
	print "	List after Sort ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Sorted insert
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(7) => {5, 1, 3, 4, 2, 1, 3, 2}
	dim as t_List myList
	
	print "SortedInsert can be used to sort lists as they're built"
	myList.SortedInsert(ScrambledNumbers())
	
	print "	List after SortedInsert ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Sorted insert on existing unsorted lists
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {5, 1, 4, 7, 2}
	dim as t_List myList = ScrambledNumbers()
	
	print "Using SortedInsert on a list will sort it if it's unsorted"
	print "	List before SortedInsert ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.SortedInsert(6)
	myList.SortedInsert(3)
	
	print "	List after SortedInsert ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Forcing all operations on the list to be Sorted by default
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {5, 1, 4, 6, 2}
	dim as t_List myList
	
	
	print "EnableSort will make Insert and SortedInsert behave the same"
	myList.EnableSort()
	myList.Insert(ScrambledNumbers())
	
	print "	List before ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.Insert(3)
	
	print "	List after insert has 3 inserted in its sorted place ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Shuffling a list to randomize it
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	randomize timer
	dim as integer ScrambledNumbers(9) => {0, 1, 2, 3, 4, 5, 6, 7, 8, 9}
	dim as t_List myList = ScrambledNumbers()
	
	print "With Shuffle we can create randomized lists"
	print "	List before Shuffle ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.Shuffle()
	
	print "	List after Shuffle ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Switch two indexes in a list with eachother
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {1, 2, 3, 4, 5}
	dim as t_List myList = ScrambledNumbers()
	
	print "Switch two indexes with each other with Switch"
	print "	List before Switch ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	
	myList.Switch(LIST_LAST, 0)
	
	print "	List after Switch ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Shift parts of the list to another index
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {1, 4, 5, 2, 3}
	dim as t_List myList = ScrambledNumbers()
	
	print "Shift parts of a list to another index"
	myList.Shift(1, 2, LIST_LAST) '// Shift items starting at 1 with length 2, to the end of the list
	
	print "	List after Shift ["& myList.Length &" entries]"
	Print "		"& myList.CSV() '// Get string of Comma Separated Values
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Finding something in a list
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	randomize timer
	dim as integer ScrambledNumbers(4) => {0, 1, 2, 3, 3}
	dim as t_List myList = ScrambledNumbers()
	myList.Shuffle()
	
	print "Find(x) returns the index of the FIRST instance of x in the list"
	Print "	"& myList.CSV()
	dim as integer index
	index = myList.Find(3)
	if index > -1 then '// We found it!
		print "		3 was found at index "& index &" ("& myList[index] &")"
	else
		print "		3 was not found in the list!"
	end if
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Finding all something in a list
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	randomize timer
	dim as integer ScrambledNumbers(5) => {0, 1, 2, 2, 2}
	dim as t_List myList = ScrambledNumbers()
	myList.Shuffle()
	
	print "Find(x, n) returns the n'th instance of x in the list"
	Print "	"& myList.CSV()
	dim as integer index
	dim as integer matchindex
	do
		index = myList.Find(2, matchindex)
		matchindex += 1
		if index > -1 then '// We found it!
			print "		2 was found at index "& index &" ("& myList[index] &")"
		else
			print "		No more 2's were found in the list!"
			exit do
		end if
	loop while index > -1
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Disallowing duplicates in lists
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(5) => {1, 1, 2, 3, 4, 4}
	dim as t_List myList
	
	print "Lists can be made unique by disallowing duplicate entries"
	myList.DisallowDuplicates()
	
	myList.Insert(ScrambledNumbers())
	myList.Insert(2)
	myList.Insert(3)
	myList.Insert(5)
	
	print "	List with no duplicates ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Removing duplicates from an existing list
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(6) => {4, 4, 1, 2, 1, 3, 4}
	dim as t_List myList = ScrambledNumbers()
	
	print "Removing duplicates from an existing list is easy with RemoveDuplicates"
	print "	List before RemoveDuplicates ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	myList.RemoveDuplicates()
	
	print "	List after RemoveDuplicates ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Options can be toggled at will
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(6) => {2, 8, 1, 7, 1, 6, 4}
	dim as t_List myList
	
	print "Options such as DisallowDuplicates and EnableSort can be toggled"
	myList.EnableSort()
	myList.DisallowDuplicates()
	
	myList.Insert(ScrambledNumbers())
	
	myList.AllowDuplicates()
	
	myList.Insert(6)
	myList.Insert(7)
	
	myList.DisableSort()
	
	myList.Insert(5)
	myList.Insert(3)
	
	print "	List ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print "	Reminder that any sorted operation will cause the entire list to sort"
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Lists are pointers
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as integer ScrambledNumbers(4) => {5, 1, 3, 4, 2}
	dim as any ptr ScrambledPointers(4) => {@ScrambledNumbers(0), @ScrambledNumbers(1), @ScrambledNumbers(2), @ScrambledNumbers(3), @ScrambledNumbers(4)}
	dim as t_List myList
	
	print "t_List was explicitly designed for use with pointers"
	myList.Insert(ScrambledPointers())
	
	print "	List of pointers after Insert ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Pointers allow handling of other types
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as single ScrambledNumbers(4) => {1.11, 2.22, 3.33, 4.44, 5.55}
	dim as t_List myList
	
	print "Using pointers to allow types other than integer or any ptr"
	for n as integer = 0 to 4
		dim as integer myIndex = myList.Insert(new single)
		if myIndex > -1 then '// If myIndex < 0 then insert failed!
			*cptr(single ptr, myList[myIndex])	=	ScrambledNumbers(n)
		end if
	next
	
	print "	List pointers ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	print "	Extracting the singles by dereferencing"
	if myList.Length then
		print "		";
		myList.ForEach(i as integer)
			print *cptr(single ptr, myList[i]);
			if i < myList.Length -1 then
				print ", ";
			else
				print
			end if
		next
	end if
	
	print "	Don't forget to clean up your created singles!"
	'// IMPORTANT: Since we created the singles we must also delete them!
	myList.ForEach(n as integer)
		delete cptr(single ptr, myList[n])
		myList.Replace(0, n)
	next
	myList.Clear()
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope




'// Simplify cleanup by binding a custom delete function
sub mySingleDeleteWithPrint(byval a as single ptr)
	print "	Deleting single located at "& a
	delete a
end sub
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as single ScrambledNumbers(4) => {1.11, 2.22, 3.33, 4.44, 5.55}
	dim as t_List myList
	
	print "Simplify cleanup by binding a custom delete function"
	myList.CustomDeleteSub(@mySingleDeleteWithPrint)
	
	for n as integer = 0 to 4
		dim as integer myIndex = myList.Insert(new single)
		if myIndex > -1 then '// If myIndex < 0 then insert failed!
			*cptr(single ptr, myList[myIndex])	=	ScrambledNumbers(n)
		end if
	next
	
	print "	List pointers ["& myList.Length &" entries]"
	Print "		"& myList.CSV()
	
	'// Because we set a custom delete .Clear will clean up our allocated singles using our custom sub
	myList.Clear()
	print "	List pointers ["& myList.Length &" entries]"
	print "	CustomDelete is also run on var destructor()"
	myList.Insert(new single)
	'// Because we set a custom delete our custom delete will be called here automatically when the myList variable is destroyed by the end of scope
end scope
print
print "Press any key to continue..."
do
	sleep 10,1
loop while inkey=""
cls





'// Custom compare function
function mySingleCompare(byval a as single ptr, byval b as single ptr) as integer
	if *a < *b then
		return -1
	elseif *a > *b then
		return 1
	end if
	return 0
end function
sub mySingleDelete(byval a as single ptr)
	delete a
end sub

Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as single ScrambledNumbers(4) => {5.55, 4.44, 11.11, 2.22, 8.88}
	dim as t_List myList
	myList.CustomDeleteSub(@mySingleDelete)
	
	print "Using CustomCompareFunction for sorting"
	for n as integer = 0 to 4
		dim as integer myIndex = myList.Insert(new single)
		if myIndex > -1 then '// If myIndex < 0 then insert failed!
			*cptr(single ptr, myList[myIndex])	=	ScrambledNumbers(n)
		end if
	next
	
	print "	Before sorting ["& myList.Length &" entries]"
	if myList.Length then
		print "		";
		myList.ForEach(i as integer)
			print *cptr(single ptr, myList[i]);
			if i < myList.Length -1 then
				print ", ";
			else
				print
			end if
		next
	end if
	
	myList.CustomCompareFunction(@mySingleCompare)
	myList.Sort()
	
	print "	After sorting ["& myList.Length &" entries]"
	if myList.Length then
		print "		";
		myList.ForEach(i as integer)
			print *cptr(single ptr, myList[i]);
			if i < myList.Length -1 then
				print ", ";
			else
				print
			end if
		next
	end if
	
	dim as single mySingle = 3.33
	dim as integer myIndex = myList.SortedInsert(@mySingle)
	
	print "	After SortedInsert using custom sort ["& myList.Length &" entries]"
	if myList.Length then
		print "		";
		myList.ForEach(i as integer)
			print *cptr(single ptr, myList[i]);
			if i < myList.Length -1 then
				print ", ";
			else
				print
			end if
		next
	end if
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// The main use of t_List is as the foundation for extension
nExample+=1
print "Example "& nExample &" / "& numExamples
print "The main purpose is extending user defined types"
type myListEntry
	Name as string
	EmployeeID as short
end type
type myListType extends t_List
	declare operator [](byval index as integer) as myListEntry ptr
	declare function Add(byref _name as string, byref _EmployeeID as integer) as integer
end type
operator myListType.[](byval index as integer) as myListEntry ptr
	return cptr(myListEntry ptr, base.GetPtr(index))
end operator
function myListType.Add(byref _name as string, byref _EmployeeID as integer) as integer
	dim as myListEntry ptr newEntry = new myListEntry
	newEntry->Name			=	_name
	newEntry->EmployeeID	=	_EmployeeID
	return this.Insert(newEntry)
end function
sub myUDTDelete(byval a as myListEntry ptr)
	delete a
end sub
scope
	dim as myListType myList
	myList.CustomDeleteSub(@myUDTDelete)
	
	myList.Add("Alice", 17)
	myList.Add("Bob", 23)
	myList.Add("Charlie", 1)

	myList.ForEach(n as integer)
		print "	["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope






'// UDT sorting
function myUDTCompare(byval a as myListEntry ptr, byval b as myListEntry ptr) as integer
	if a->EmployeeID < b->EmployeeID then
		return -1
	elseif a->EmployeeID > b->EmployeeID then
		return 1
	end if
	return 0
end function
scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as myListType myList
	myList.CustomDeleteSub(@myUDTDelete)
	
	print "Sorting UDTs by defining a custom compare function"
	myList.CustomCompareFunction(@myUDTCompare)
	
	myList.Add("Alice", 17)
	myList.Add("Bob", 23)
	myList.Add("Charlie", 1)
	
	print "	UDT list before sorting ["& myList.Length &" entries]"
	myList.ForEach(n as integer)
		print "		["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	
	myList.sort()
	print "	UDT list after sorting by employee ID ["& myList.Length &" entries]"
	myList.ForEach(n as integer)
		print "		["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope






'// UDT shuffle
scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as myListType myList
	myList.CustomDeleteSub(@myUDTDelete)
	
	print "Shuffle works fine for UDTs as well"
	
	myList.Add("Alice", 17)
	myList.Add("Bob", 23)
	myList.Add("Charlie", 1)
	myList.Add("David", 4)
	myList.Add("Emily", 103)
	
	print "	UDT list before shuffle ["& myList.Length &" entries]"
	myList.ForEach(n as integer)
		print "		["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	
	myList.Shuffle()
	
	print "	UDT list after shuffle ["& myList.Length &" entries]"
	myList.ForEach(n as integer)
		print "		["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope






'// UDT duplicates
nExample+=1
print "Example "& nExample &" / "& numExamples
function myUDTNameCompare(byval a as myListEntry ptr, byval b as myListEntry ptr) as integer
	if a->Name < b->Name then
		return -1
	elseif a->Name > b->Name then
		return 1
	end if
	return 0
end function
scope
	dim as myListType myList
	myList.CustomDeleteSub(@myUDTDelete)
	
	print "Duplicate handling works for UDTs via the CustomCompareFunction"
	myList.CustomCompareFunction(@myUDTNameCompare)
	myList.DisallowDuplicates()
	
	
	myList.Add("Alice", 17)
	myList.Add("Bob", 23)
	myList.Add("Charlie", 1)
	myList.Add("Alice", 1)
	myList.Add("Alice", 1336)
	myList.Add("Bob", 9001)
	
	
	myList.ForEach(n as integer)
		print "	["& myList[n]->EmployeeID &"] "& myList[n]->Name
	next
	print
	print "Press any key to continue..."
	do
		sleep 10,1
	loop while inkey=""
	cls
end scope





'// Find in UDT
Scope
	nExample+=1
	print "Example "& nExample &" / "& numExamples
	dim as myListType myList, searchParam
	myList.CustomDeleteSub(@myUDTDelete)
	
	print "Find works for UDTs as well"
	myList.CustomCompareFunction(@myUDTNameCompare)
	
	myList.Add("Alice", 17)
	myList.Add("Bob", 23)
	myList.Add("Charlie", 1)
	myList.Add("Alice", 1)
	myList.Add("Alice", 1336)
	myList.Add("Bob", 9001)
	myList.Shuffle()
	
	myList.ForEach(n as integer)
		if n = 0 then
			print "	["& myList[n]->EmployeeID &"] "& myList[n]->Name;
		else
			print ", ["& myList[n]->EmployeeID &"] "& myList[n]->Name;
		end if
	next
	print
	
	dim as integer index
	dim as integer matchindex
	
	searchParam.Add("Alice", 0)
	
	do
		index = myList.Find(searchParam[0], matchindex) '// searchParam[0] is "Alice"
		matchindex += 1
		if index > -1 then '// We found it!
			print "		'"& searchParam[0]->Name &"' was found at index "& index &" (["& myList[index]->EmployeeID &"] "& myList[index]->Name &")"
		else
			print "		No more '"& searchParam[0]->Name &"' were found in the list!"
			exit do
		end if
	loop while index > -1
	print
	
end scope



Print "You've reached the end of the examples list!"
sleep
end